/*******************************************************************************
 * Copyright (c) 2012, 2018 Willink Transformations and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.qvtd.xtext.qvtrelationcs;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.qvtd.xtext.qvtrelationcs.QVTrelationCSPackage
 * @generated
 */
public interface QVTrelationCSFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	QVTrelationCSFactory eINSTANCE = org.eclipse.qvtd.xtext.qvtrelationcs.impl.QVTrelationCSFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Collection Template CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Collection Template CS</em>'.
	 * @generated
	 */
	CollectionTemplateCS createCollectionTemplateCS();

	/**
	 * Returns a new object of class '<em>Default Value CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Default Value CS</em>'.
	 * @generated
	 */
	DefaultValueCS createDefaultValueCS();

	/**
	 * Returns a new object of class '<em>Domain CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Domain CS</em>'.
	 * @generated
	 */
	DomainCS createDomainCS();

	/**
	 * Returns a new object of class '<em>Domain Pattern CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Domain Pattern CS</em>'.
	 * @generated
	 */
	DomainPatternCS createDomainPatternCS();

	/**
	 * Returns a new object of class '<em>Element Template CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Element Template CS</em>'.
	 * @generated
	 */
	ElementTemplateCS createElementTemplateCS();

	/**
	 * Returns a new object of class '<em>Key Decl CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Key Decl CS</em>'.
	 * @generated
	 */
	KeyDeclCS createKeyDeclCS();

	/**
	 * Returns a new object of class '<em>Model Decl CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model Decl CS</em>'.
	 * @generated
	 */
	ModelDeclCS createModelDeclCS();

	/**
	 * Returns a new object of class '<em>Object Template CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Object Template CS</em>'.
	 * @generated
	 */
	ObjectTemplateCS createObjectTemplateCS();

	/**
	 * Returns a new object of class '<em>Param Declaration CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Param Declaration CS</em>'.
	 * @generated
	 */
	ParamDeclarationCS createParamDeclarationCS();

	/**
	 * Returns a new object of class '<em>Pattern CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Pattern CS</em>'.
	 * @generated
	 */
	PatternCS createPatternCS();

	/**
	 * Returns a new object of class '<em>Predicate CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Predicate CS</em>'.
	 * @generated
	 */
	PredicateCS createPredicateCS();

	/**
	 * Returns a new object of class '<em>Primitive Type Domain CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Primitive Type Domain CS</em>'.
	 * @generated
	 */
	PrimitiveTypeDomainCS createPrimitiveTypeDomainCS();

	/**
	 * Returns a new object of class '<em>Property Template CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Property Template CS</em>'.
	 * @generated
	 */
	PropertyTemplateCS createPropertyTemplateCS();

	/**
	 * Returns a new object of class '<em>Query CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Query CS</em>'.
	 * @generated
	 */
	QueryCS createQueryCS();

	/**
	 * Returns a new object of class '<em>Relation CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Relation CS</em>'.
	 * @generated
	 */
	RelationCS createRelationCS();

	/**
	 * Returns a new object of class '<em>Top Level CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Top Level CS</em>'.
	 * @generated
	 */
	TopLevelCS createTopLevelCS();

	/**
	 * Returns a new object of class '<em>Transformation CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Transformation CS</em>'.
	 * @generated
	 */
	TransformationCS createTransformationCS();

	/**
	 * Returns a new object of class '<em>Var Declaration CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Var Declaration CS</em>'.
	 * @generated
	 */
	VarDeclarationCS createVarDeclarationCS();

	/**
	 * Returns a new object of class '<em>Var Declaration Id CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Var Declaration Id CS</em>'.
	 * @generated
	 */
	VarDeclarationIdCS createVarDeclarationIdCS();

	/**
	 * Returns a new object of class '<em>Primitive Type Domain Pattern CS</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Primitive Type Domain Pattern CS</em>'.
	 * @generated
	 */
	PrimitiveTypeDomainPatternCS createPrimitiveTypeDomainPatternCS();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	QVTrelationCSPackage getQVTrelationCSPackage();

} //QVTrelationCSTFactory
